var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  createSwaggerSpec: () => createSwaggerSpec,
  withSwagger: () => withSwagger
});
module.exports = __toCommonJS(src_exports);

// src/swagger.ts
var import_path = require("path");
var import_swagger_jsdoc = __toESM(require("swagger-jsdoc"), 1);
var defaultOptions = {
  apiFolder: "pages/api",
  schemaFolders: [],
  definition: {
    openapi: "3.0.0",
    info: {
      title: "Next Swagger Doc Demo Api",
      version: "1.0"
    }
  }
};
function createSwaggerSpec(_a = defaultOptions) {
  var _b = _a, {
    apiFolder = "pages/api",
    schemaFolders = []
  } = _b, swaggerOptions = __objRest(_b, [
    "apiFolder",
    "schemaFolders"
  ]);
  const scanFolders = [apiFolder, ...schemaFolders];
  const apis = scanFolders.flatMap((folder) => {
    const buildApiDirectory = (0, import_path.join)(process.cwd(), ".next/server", folder);
    const apiDirectory = (0, import_path.join)(process.cwd(), folder);
    const publicDirectory = (0, import_path.join)(process.cwd(), "public");
    const fileTypes = ["ts", "tsx", "jsx", "js", "json", "swagger.yaml"];
    return [
      ...fileTypes.map((fileType) => `${apiDirectory}/**/*.${fileType}`),
      ...["js", "swagger.yaml", "json"].map((fileType) => `${buildApiDirectory}/**/*.${fileType}`),
      ...["swagger.yaml", "json"].map((fileType) => `${publicDirectory}/**/*.${fileType}`)
    ];
  });
  const options = __spreadValues({
    apis
  }, swaggerOptions);
  const spec = (0, import_swagger_jsdoc.default)(options);
  return spec;
}
function withSwagger(_a = defaultOptions) {
  var _b = _a, {
    apiFolder = "pages/api",
    schemaFolders = []
  } = _b, swaggerOptions = __objRest(_b, [
    "apiFolder",
    "schemaFolders"
  ]);
  return () => (_req, res) => {
    try {
      const swaggerSpec = createSwaggerSpec(__spreadValues({
        apiFolder,
        schemaFolders
      }, swaggerOptions));
      res.status(200).send(swaggerSpec);
    } catch (error) {
      res.status(400).send(error);
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createSwaggerSpec,
  withSwagger
});
//# sourceMappingURL=index.cjs.map